import java.applet.*;
import java.awt.*;

public class CrossHair extends Applet
{
    // User data here
    private Dimension m_dimCursorLoc;  // location of cursor
    private boolean m_bDrag;   // TRUE->we are currently dragging
    private FontMetrics m_fm;  // font metrics

	public CrossHair()
	{
	}

	public String getAppletInfo()
	{
		return "Name: CrossHair\r\n" +
		       "Author: Stephen R. Davis\r\n" +
		       "Created for Learn Java Now (c)";
	}


	public void init()
	{
		resize(640, 480);

        // Let's get the font metrics so we know how big our
        // font really is
        Font f = getFont();
        m_fm = getFontMetrics(f);
	}

	public void destroy()
	{
	}

    // CrossHair Paint Handler
    //-----------------------------------------------------------
	public void paint(Graphics g)
	{
        // first build a string containing the current cursor
        // location in the format (xx,yy) and output that
        String sCursorLoc = "("
                            + m_dimCursorLoc.width
                            + ","
                            + m_dimCursorLoc.height
                            + ")";
        // calculate the y offset of line 2
        // (this is 2 * the height of the font)
        int nY = 2 * m_fm.getHeight();

        // (set x so that the string ends 5 pixels from
        // the right hand side of the window)
        Dimension dimWinSize = size();    // size of the window
        int nWidth = m_fm.stringWidth(sCursorLoc);
        int nX = dimWinSize.width - (nWidth + 5);

        // now paint the string at that location
        g.drawString(sCursorLoc, nX, nY);

        // now put an x where the cursor is located
        // (make it red if we are dragging and black if not)
        if (m_bDrag)
        {
            g.setColor(Color.red);
        }
        else
        {
            g.setColor(Color.black);
        }
        nX = m_dimCursorLoc.width;
        nY = m_dimCursorLoc.height;
        g.drawLine(nX - 2,     nY, nX + 2,     nY);
        g.drawLine(    nX, nY - 2,     nX, nY + 2);
	}

	public void start()
	{
	}
	
	public void stop()
	{
	}



    // MOUSE SUPPORT:
    //-----------------------------------------------------------
	public boolean mouseDrag(Event evt, int x, int y)
	{
        // set the drag mode to true
        m_bDrag = true;

        // record the mouse location
        m_dimCursorLoc = new Dimension(x, y);

        // now force a repaint - this will repaint the window 
        // with the cross hair at the current mouse location
        repaint();

        // returning true indicates that we handled the event
		return true;
	}

    // MOUSE SUPPORT:
    //-----------------------------------------------------------
	public boolean mouseMove(Event evt, int x, int y)
	{
        // same as mouseDrag with drag mode turned off
        m_bDrag = false;
        m_dimCursorLoc = new Dimension(x, y);
        repaint();

		return true;
	}

}
